-- ud_149_20170220.sql
-- CC5B21E2F12B895B55C089D9975953B6

CREATE OR ALTER VIEW KARTA_VIEWER(
    IDK,
    ID_REP,
    NHISTORY,
    SPOLIS,
    NPOLIS,
    SMO,
    MCOD,
    FAM,
    IM,
    OT,
    W,
    DR,
    STAGE,
    DATE_ENTER,
    DATE_1,
    DATE_2,
    RSLT,
    MD5_HASH,
    TD,
    GD,
    MON,
    IN_REP,
    DOCTYPE,
    DOCSER,
    DOCNUM,
    SNILS,
    IS_MD,
    ISOUT,
    SANK_MEK,
    IS_MEK,
    HARD_LINK,
    DS_LIST)
AS
select K.IDK, K.ID_REP, K.NHISTORY, K.SPOLIS, K.NPOLIS, K.SMO, K.MCOD, K.FAM, K.IM, K.OT, K.W, K.DR, K.STAGE,
       K.DATE_ENTER, K.DATE_1, K.DATE_2, K.RSLT, K.MD5_HASH, K.TD, extract(year from K.DATE_ENTER) as GD,
       extract(month from K.DATE_ENTER) as MON, iif(K.ID_REP is null, 0, 1) as IN_REP, K.DOCTYPE, K.DOCSER, K.DOCNUM,
       K.SNILS,
       (iif((select count(*)
             from KARTA_USL KU
             inner join USL U on ((U.ID = KU.ID_USL) and
                   (U.IS_DOP_TARIF = '1'))
             where (KU.IDK = K.IDK) and
                   (U.IS_FINAL_MD = '1') and
                   (not KU.ID_MD is null) and
                   (KU.ID_MD <> 0)) = 0, '', '')) as IS_MD,
       (select P.ISOUT
        from P_KARTA P
        where P.IDK = K.IDK) as ISOUT,
        k.sank_mek, (iif(k.sank_mek is null, '','')),
        k.hard_link,
        (select list(d.ds_cod, ', ') from ds d where d.idk=k.idk) as ds_list
from KARTA K
order by K.DATE_ENTER, upper(K.FAM collate PXW_CYRL), upper(K.IM collate PXW_CYRL), upper(K.OT collate PXW_CYRL), K.DR, K.TD, K.STAGE, K.IDK; @