-- ud_222_20191118.sql
-- A9810F9901E6700781B9133698090CC0

create or alter procedure TMP_USL_IM_TO_USL
as
declare variable IDK integer;
declare variable USL_CODE varchar(16);
declare variable DATE_OK date;
declare variable IS_FIND varchar(1);
declare variable REFUSAL integer;
declare variable AGE integer;
declare variable W integer;
declare variable TD integer;
declare variable STAGE integer;
declare variable ID_USL integer;
begin

for select tu.idk,tu.usl_code,tu.date_ok,tu.is_find,tu.refusal,
           case when k.td<>7 then k.age else case when k.age<18 then 0 else 1 end end,
           k.w,k.td,k.stage
    from tmp_usl_im tu
      inner join karta k on tu.idk=k.idk
  into: idk, usl_code,date_ok,is_find,refusal,age,w,td,stage
do
begin

    select u.id
    from usl u
    where u.date_2 is null
        and u.td=:td
        and u.stage=:stage
        and (u.w=:w or u.w=0)
        and (u.age=:age or (u.age is null and :age<=u.first_sl))
        and u.usl_code=:usl_code
  into: id_usl;

    insert into karta_usl (idk, id_usl,date_ok,is_find,refusal)
    values (:idk,:id_usl,:date_ok,:is_find,:refusal);

end
end; @

COMMIT WORK; @						